#load "graphics.cma"
#load "ease.cmo"

let fs = [|
  "Ease.Linear",     Ease.Linear;
  "Ease.QuadIn",     Ease.QuadIn;
  "Ease.CubicIn",    Ease.CubicIn;
  "Ease.QuartIn",    Ease.QuartIn;

  "Ease.QuadOut",    Ease.QuadOut;
  "Ease.CubicOut",   Ease.CubicOut;
  "Ease.QuartOut",   Ease.QuartOut;

  "Ease.QuadInOut",  Ease.QuadInOut;
  "Ease.CubicInOut", Ease.CubicInOut;
  "Ease.QuartInOut", Ease.QuartInOut;
|]

let border = 20
let size = 200
let b_size = size + (2 * border)
let f_size = float size

let () =
  Graphics.open_graph "";
  Graphics.resize_window b_size b_size;
  let fi = ref 0 in
  let n = Array.length fs in
  while true do
    let name, f = fs.(!fi) in
    let f = Ease.f f in
    (*
    let f v = f (Ease1.mirror v) in
    *)
    Graphics.clear_graph ();
    Graphics.draw_rect border border size size;
    Graphics.moveto 6 (b_size - 16);
    Graphics.draw_string name;
    for i = 0 to pred (size * 2) do
      let x = (float i) /. 2.0 /. f_size in
      let y = f x in
      let coord v = truncate (v *. f_size) + border in
      let x = coord x in
      let y = coord y in
      Graphics.plot x y
    done;
    let k = Graphics.read_key () in
    if (int_of_char k) = 27 then exit 0;
    fi := (1 + !fi) mod n
  done
