(** Timeline *)

(** {3 timeline types} *)

type time = float

type 'a animated = At of time * 'a | Change of time * time * 'a * 'a

type 'a timed = Static of 'a | Animated of 'a animated list

type float1 = float timed
type float2 = (float * float) timed
type float3 = (float * float * float) timed
type float4 = (float * float * float * float) timed

(** {3 Timeline functions} *)

val inter1 :
  float -> float -> float ->
  float ->
  float ->
  float

val inter2 :
  float -> float -> float ->
  float * float ->
  float * float ->
  float * float

val inter3 :
  float -> float -> float ->
  float * float * float ->
  float * float * float ->
  float * float * float

val inter4 :
  float -> float -> float ->
  float * float * float * float ->
  float * float * float * float ->
  float * float * float * float

val val_at :
  (time -> time -> time -> 'a -> 'a -> 'a) ->
    time -> 'a animated list -> 'a

val get_val :
  (time -> time -> time -> 'a -> 'a -> 'a) ->
    time -> 'a timed -> 'a

val get_val1 : time -> float1 -> float
val get_val2 : time -> float2 -> float * float
val get_val3 : time -> float3 -> float * float * float
val get_val4 : time -> float4 -> float * float * float * float

